// 002 u_c_cgi_client_socket
// 15 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_cgi_client_socket;
  interface
    uses u_c_client_socket_4
         ;

    type c_cgi_client_socket= Class; // forward
         t_po_cgi_event= procedure(p_c_cgi_client_socket: c_cgi_client_socket) of Object;

         c_cgi_client_socket= class(c_client_socket)
                                m_content_length: Integer;
                                m_answer: String;

                                m_on_cgi_connected: t_po_cgi_event;
                                m_on_after_received_cgi_answer: t_po_cgi_event;

                                Constructor create_cgi_client_socket(p_name: String);

                                procedure connect(p_ip_address, p_port: String);
                                procedure handle_cgi_connected(p_c_client_socket: c_client_socket);
                                procedure handle_received_data(p_c_client_socket: c_client_socket);
                                procedure send_request(p_request, p_cgi_exe: String);

                                Destructor Destroy; Override;
                              end; // c_cgi_client_socket

  implementation
    uses SysUtils, u_c_display;

    // -- c_cgi_client_socket

    Constructor c_cgi_client_socket.create_cgi_client_socket(p_name: String);
      begin
        Inherited create_client_socket(p_name);

        m_on_after_socket_connected:= handle_cgi_connected;
        m_on_after_socket_received_data:= handle_received_data;
      end; // create_cgi_client_socket

    procedure c_cgi_client_socket.connect(p_ip_address, p_port: String);
      begin
        wsa_startup;
        create_win_socket;
        wsa_select;
        do_connect_win_socket(p_ip_address, StrToInt(p_port));
      end; // connect

    procedure c_cgi_client_socket.handle_cgi_connected(p_c_client_socket: c_client_socket);
        // -- simple relay
      begin
        display('> c_cgi_client_socket.connected');
        if Assigned(m_on_cgi_connected)
          then m_on_cgi_connected(Self);
        display('< c_cgi_client_socket.connected');
      end; // handle_cgi_connected

    procedure c_cgi_client_socket.send_request(p_request, p_cgi_exe: String);
      begin
        f_do_send_string(
            'POST /scripts/'+ p_cgi_exe+ ' HTTP/1.0'#13#10
            + 'Accept: *'#13#10
            + 'User-Agent: my_agent'#13#10
            + 'Content-Length='+ IntToStr(Length(p_request))+ #13#10
            + #13#10
            + p_request);
      end; // send_request

    procedure c_cgi_client_socket.handle_received_data(p_c_client_socket: c_client_socket);
        // -- fd_read notification was received
      var l_end_of_header_position: Integer;
          l_content_length_position: Integer;
          l_content_length_string: String;
      begin
        display('> g_received');

        with m_c_reception_buffer do
        begin
          l_end_of_header_position:= f_next_2_new_line_position(0);

          if l_end_of_header_position> 0
            then begin
                display(f_extract_string_start_end(0, m_write_index- 1));
                l_content_length_position:= f_string_position(0, 'Content-Length');
                // display('content_length_position '+ IntToStr(l_content_length_position));
                Inc(l_content_length_position, Length('Content-Length')+ 1);
                l_content_length_string:= f_extract_eol(l_content_length_position);
                display('content_length >'+ l_content_length_string+ '<');

                if l_content_length_string<> ''
                  then begin
                      m_content_length:= StrToInt(l_content_length_string);
                      m_read_index:= l_end_of_header_position+ 4;

                      if m_write_index- m_read_index= m_content_length
                        then begin
                            m_answer:= f_extract_string_start_end(m_read_index, m_write_index- 1);
                            if Assigned(m_on_after_received_cgi_answer)
                              then m_on_after_received_cgi_answer(Self);
                          end
                        else display(IntToStr(m_write_index- m_read_index)+ ' <> '+ IntToStr(m_content_length));
                    end;
              end;
        end; // with m_c_reception_buffer

        display('< g_received');
      end; // handle_received_data

    Destructor c_cgi_client_socket.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_cgi_client_socket
    end. // u_c_cgi_client_socket


