// 002 u_cgi_web_browser
// 18 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_cgi_web_browser;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
        StdCtrls
       , ComCtrls, ExtCtrls, FileCtrl
       , u_c_base_socket_4
       , u_c_client_socket_4
       , u_c_cgi_client_socket
       ;

    type TForm1= class(TForm)
                  Panel1: TPanel;
                  port_edit_: TEdit;
                  server_ip_addres_edit_: TEdit;
                  PageControl1: TPageControl;
                  TabSheet1: TTabSheet;
                  TabSheet2: TTabSheet;
                  Memo1: TMemo;
                  Memo2: TMemo;
                  clear_: TButton;
                  create_: TPanel;
                  close_: TPanel;
                  exit_: TButton;
                  send_: TPanel;
                  database_: TCheckBox;
                  uml_design_patterns_: TCheckBox;
                  oo_programming_: TCheckBox;
                  e_mail_edit_: TEdit;
                   procedure CloseSocket_Click(Sender: TObject);
                   procedure FormCreate(Sender: TObject);
                   procedure create_Click(Sender: TObject);
                   procedure clear_Click(Sender: TObject);
                   procedure exit_Click(Sender: TObject);
                   procedure send_Click(Sender: TObject);
                   private
                     procedure handle_connected(p_c_cgi_client_socket: c_cgi_client_socket);
                     procedure handle_received_answer(p_c_cgi_client_socket: c_cgi_client_socket);
                     procedure handle_socket_closed(p_c_base_socket: c_base_socket);
                   public
                 end;

    var Form1: TForm1;

  implementation
    uses u_types_constants, u_c_display, u_c_log, u_strings
       ;

    {$R *.DFM}

 
    const k_site_path= '..\..\_site\';

    var g_c_cgi_client_socket: c_cgi_client_socket;

    procedure set_panel_color(p_c_panel: tPanel; p_color: Integer);
      begin
        p_c_panel.Color:= p_color;
        Application.ProcessMessages;
      end; // set_panel_color

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        set_panel_color(create_, clLime);
        set_panel_color(send_, clRed);
        set_panel_color(close_, clRed);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.create_Click(Sender: TObject);
      begin
        // g_c_cgi_client_socket.Free;
        g_c_cgi_client_socket:= c_cgi_client_socket.create_cgi_client_socket('client');

        with g_c_cgi_client_socket do
        begin
          m_trace_socket:= True;

          m_on_cgi_connected:= handle_connected;
          m_on_after_received_cgi_answer:= handle_received_answer;
          m_on_after_do_close_socket:= handle_socket_closed;

          connect(server_ip_addres_edit_.Text, port_edit_.Text);
        end; // with g_c_cgi_client_socket

        set_panel_color(create_, clRed);
      end; // create_Click

    procedure TForm1.handle_connected(p_c_cgi_client_socket: c_cgi_client_socket);
      begin
        display('> connected');
        send_.Enabled:= True;
        set_panel_color(send_, clLime);
        set_panel_color(close_, clLime);
        display('< connected');
      end; // handle_connected

    procedure TForm1.send_Click(Sender: TObject);
      var l_request: String;
      begin
        // -- start the HTTP protocol

        // -- build a request similar to a CGI form
        // l_request:= 'database=on&e_mail=me@my_site.com';
        if database_.Checked
          then l_request:= 'database=on&'
          else l_request:= '';
        if oo_programming_.Checked
          then l_request:= l_request+ 'oo=on&';
        if uml_design_patterns_.Checked
          then l_request:= l_request+ 'uml_dp=on&';
        if e_mail_edit_.Text<> ''
          then l_request:= l_request+ 'e_mail='+ e_mail_edit_.Text;
        f_remove_end_if_end_is_equal_to(l_request, '&');  

        g_c_cgi_client_socket.send_request(l_request, 'training_information.exe');
      end; // send_Click

    procedure tForm1.handle_received_answer(p_c_cgi_client_socket: c_cgi_client_socket);
      begin
        display('result_in_memo2 '+ IntToStr(Length(p_c_cgi_client_socket.m_answer)));
        Memo2.Lines.Text:= p_c_cgi_client_socket.m_answer;
      end; // handle_received_answer
      
    procedure TForm1.CloseSocket_Click(Sender: TObject);
      begin
        g_c_cgi_client_socket.do_close_win_socket;
      end; // CloseSocket_Click

    procedure TForm1.handle_socket_closed(p_c_base_socket: c_base_socket);
      begin
        g_c_cgi_client_socket.Free;
        g_c_cgi_client_socket:= Nil;

        set_panel_color(create_, clLime);
        set_panel_color(send_, clRed);
        set_panel_color(close_, clRed);
      end; // handle_socket_closed

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click


end.
